# generated by datamodel-codegen:
#   filename:  cm_json.json
#   timestamp: 2022-12-21T09:36:26+00:00

from __future__ import annotations

from enum import Enum
from pydantic import BaseModel, Extra, Field
from typing import Any, Dict, List, Optional, Union
from uuid import UUID


class ContactChannel(Enum):
    """
    In which way the case ended in creation
    """

    behandelaar = "behandelaar"
    balie = "balie"
    telefoon = "telefoon"
    post = "post"
    email = "email"
    webformulier = "webformulier"
    sociale_media = "sociale media"


class Type(Enum):
    """
    Type of the requestor(employee/organization/person)
    """

    employee = "employee"
    person = "person"
    organization = "organization"


class Requestor(BaseModel):
    """
    Requestor (employee/organization/person) of case
    """

    type: Optional[Type] = Field(
        None, description="Type of the requestor(employee/organization/person)"
    )
    id: Optional[UUID] = Field(None, description="UUID of the requestor")


class Confidentiality(Enum):
    """
    Confidentiality for the case.
    """

    public = "public"
    internal = "internal"
    confidential = "confidential"


class Type1(Enum):
    role = "role"


class Role(BaseModel):
    class Config:
        extra = Extra.forbid

    id: UUID
    type: Type1


class Type2(Enum):
    department = "department"


class Department(BaseModel):
    class Config:
        extra = Extra.forbid

    id: UUID
    type: Type2


class AssignmentItem(BaseModel):
    class Config:
        extra = Extra.forbid

    role: Optional[Role] = None
    department: Optional[Department] = None


class Type3(Enum):
    employee = "employee"


class Employee(BaseModel):
    class Config:
        extra = Extra.forbid

    id: UUID
    type: Type3
    use_employee_department: Optional[bool] = None
    send_email_notification: Optional[bool] = None


class AssignmentItem1(BaseModel):
    class Config:
        extra = Extra.forbid

    employee: Optional[Employee] = None


class ContactInformation(BaseModel):
    """
    Contact information for case
    """

    class Config:
        extra = Extra.forbid

    mobile_number: Optional[str] = Field(None, description="Mobile number of requestor")
    phone_number: Optional[str] = Field(None, description="Phone number of requestor")
    email: Optional[str] = Field(None, description="Email address for the requestor")


class Options(BaseModel):
    class Config:
        extra = Extra.forbid

    allow_missing_required_fields: Optional[bool] = None


class ApiV2CmCaseCreateCasePostRequest(BaseModel):
    class Config:
        extra = Extra.forbid

    case_uuid: UUID = Field(
        ...,
        description="UUID of the case to be created. If case_uuid field is missing, then back-end"
        + "will generate one",
    )
    case_type_version_uuid: UUID = Field(
        ..., description="UUID of the Casetype the case descended from."
    )
    contact_channel: ContactChannel = Field(
        ..., description="In which way the case ended in creation"
    )
    requestor: Requestor = Field(
        ..., description="Requestor (employee/organization/person) of case"
    )
    confidentiality: Optional[Confidentiality] = Field(
        None, description="Confidentiality for the case."
    )
    custom_fields: Optional[Dict[str, List[Union[float, str, List[str], Dict[str, Any]]]]] = Field(
        None, description="Custom fields for the case."
    )
    assignment: Optional[Union[AssignmentItem, AssignmentItem1]] = None
    contact_information: Optional[ContactInformation] = Field(
        None, description="Contact information for case"
    )
    options: Optional[Options] = None
